# coding: utf-8

"""
    REST API

    Rockset's REST API allows for creating and managing all resources in Rockset. Each supported endpoint is documented below.  All requests must be authorized with a Rockset API key, which can be created in the [Rockset console](https://console.rockset.com). The API key must be provided as `ApiKey <api_key>` in the `Authorization` request header. For example: ``` Authorization: ApiKey aB35kDjg93J5nsf4GjwMeErAVd832F7ad4vhsW1S02kfZiab42sTsfW5Sxt25asT ```  All endpoints are only accessible via https.  Build something awesome!  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from rockset.configuration import Configuration


class QueryLambdaSql(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'default_parameters': 'list[QueryParameter]',
        'query': 'str'
    }

    attribute_map = {
        'default_parameters': 'default_parameters',
        'query': 'query'
    }

    def __init__(self, default_parameters=None, query=None, local_vars_configuration=None):  # noqa: E501
        """QueryLambdaSql - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._default_parameters = None
        self._query = None
        self.discriminator = None

        if default_parameters is not None:
            self.default_parameters = default_parameters
        self.query = query

    @property
    def default_parameters(self):
        """Gets the default_parameters of this QueryLambdaSql.  # noqa: E501

        default parameters for this Query Lambda  # noqa: E501

        :return: The default_parameters of this QueryLambdaSql.  # noqa: E501
        :rtype: list[QueryParameter]
        """
        return self._default_parameters

    @default_parameters.setter
    def default_parameters(self, default_parameters):
        """Sets the default_parameters of this QueryLambdaSql.

        default parameters for this Query Lambda  # noqa: E501

        :param default_parameters: The default_parameters of this QueryLambdaSql.  # noqa: E501
        :type default_parameters: list[QueryParameter]
        """

        self._default_parameters = default_parameters

    @property
    def query(self):
        """Gets the query of this QueryLambdaSql.  # noqa: E501

        SQL text  # noqa: E501

        :return: The query of this QueryLambdaSql.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this QueryLambdaSql.

        SQL text  # noqa: E501

        :param query: The query of this QueryLambdaSql.  # noqa: E501
        :type query: str
        """
        if self.local_vars_configuration.client_side_validation and query is None:  # noqa: E501
            raise ValueError("Invalid value for `query`, must not be `None`")  # noqa: E501

        self._query = query

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryLambdaSql):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryLambdaSql):
            return True

        return self.to_dict() != other.to_dict()
